#!/usr/bin/env perl
use strict;
use warnings;

use HTML::ExtractContent;
use LWP::UserAgent;
use Lingua::JA::TFIDF;

my $url = shift or die "usage: $0 <url>\n";
my $text = url2text($url);

my $tfidf = Lingua::JA::TFIDF->new;
my $result = $tfidf->tfidf($text);

for (@{$result->list}) {
    my ($term, $tfidf) = %$_;
    printf "%.1f\t%s\n", $tfidf, $term;
}

sub url2text {
    my $url = shift;

    my $ua  = LWP::UserAgent->new;
    my $res = $ua->get($url);

    if ($res->is_error) {
        die $res->status_line;
    }

    my $html = $res->decoded_content;
    my $ex = HTML::ExtractContent->new;
    $ex->extract($html);
    return $ex->as_text;
}
